<template>
  <v-container fluid>
    <v-slide-y-transition mode="out-in">
      <v-layout column >
        <div v-if="returnCode == 200 || returnCode == 201">
          <p style="text-align: right;" v-if="!nonEditablePage">
            <a style="color: #1976d2" v-on:click="returnCode = 600">Modifier la page</a> | 
            <a style="color: #1976d2" v-on:click="deletePage">Supprimer la page</a>
          </p>
          <p v-html="page">
          </p>
        </div>
        <div v-else-if="returnCode == 404">
          <p>Cette page n'existe pas ! Voulez vous créer {{ url }}</p>
            <p><button v-on:click="returnCode = 600;newPage = true">Créer la page</button></p>
        </div>
        <div v-else-if="returnCode == 600">
          <div v-if="newPage">
            <textarea type="text" v-model="RawPage"></textarea>
            <p style="text-align: right;"><button v-on:click="createPage">Créer</button></p>
          </div>
          <div v-else>
            <textarea type="text" v-model="RawPage"></textarea>
            <p style="text-align: right;"><button v-on:click="updatePage">Mettre à jour</button></p>
          </div>
        </div>
        <div v-else></div>
      </v-layout>
    </v-slide-y-transition>
  </v-container>
</template>


<script>
import marked from 'marked'
const reqAxios = require('axios')
const axios = reqAxios.create({baseURL: 'http://localhost:8081/api'});

export default {
  name: 'DisplayPage',
  props: {
    msg: String,
  },
  data(){
    return{
      RawPage: null,
      returnCode: null,
      url : null,
      newPage: null,
      nonEditablePage: null
    }
  },
  mounted: async function() {
    this.url = window.location.pathname
    let backurl = null
    if (this.url === "/list" | this.url === "/random") {
      backurl = this.url
      this.nonEditablePage = true
    } else {
      backurl = '/pages?path='+this.url
      this.nonEditablePage = false
    }
    try{
      let response = await axios.get(backurl)
      if (this.url==="/random"){
          window.location.replace(response.data)
      }
      this.RawPage = response.data
      if (this.url === "/list"){
          this.RawPage=""
          console.log(response.data.length)
          if (response.data.length === 0) {
            this.RawPage = "Il n'y a aucune page dans ce wiki :-("
          }
          for (var i in response.data){
            console.log(response.data[i])
            this.RawPage+= "* " + "["+response.data[i]+"]("+response.data[i]+' "'+response.data[i]+'")  \n'
          }
      }
      this.returnCode = response.status
    }catch(error){
      this.returnCode = error.response.status
    }
    console.log(this.returnCode)
  },
  methods: {
    async updatePage() {
      this.url = window.location.pathname
      let backurl = '/pages?path='+this.url
      try {
        let response = await axios.put(backurl, {"content": this.RawPage})
        this.returnCode = response.status
        console.log(this.returnCode)
      }catch(error){
        this.returnCode = 500
      }
      console.log(this.returnCode)
    },
    async createPage() {
      this.url = window.location.pathname
      let backurl = '/pages?path='+this.url
      try {
        let response = await axios.post(backurl, {"content": this.RawPage})
        this.returnCode = response.status
        console.log(this.returnCode)
      }catch(error){
        this.returnCode = 500
        console.log(error)
      }
      console.log(this.returnCode)
    },
    async deletePage() {
      this.url = window.location.pathname
      let backurl = '/pages?path='+this.url
      try{
        let response = await axios.delete(backurl)
        this.returnCode = response.status
        console.log(this.returnCode)
        window.location.replace("")
      }catch(error){
        this.returnCode = 500
        console.log(error)
      }
    }
  },
  computed: {
    page: function () {
      return marked(this.RawPage)
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}
button {
    background-color: grey; /* Green */
    border: none;
    color: white;
    padding: 10px 17px;
    text-align: center;
    text-decoration: none;
    display: inline-block;
    font-size: 16px;
}
textarea{
  background:white;
  width:100%;
  border: 1px solid #888; 
  height: 400px;
}
</style>
